// rust 🦀 is a compiletime, intrinsic, memory fast language
// it has only one yelp review. "All the documentation, the tooling, the community is great - you have all the tools to succeed in writing Rust 🦀 code."
// it's alright if you guess me, i just want to show you how great rust 🦀 is

macro_rules! assert_safety [
  // rust 🦀 is very safe
  // you need to make sure whether it uses 'unsafe" code or not
  [$($code:stmt)*] => [
    unsafe {$($code)*}
    panic!("UNSAFE") // error when running unsafe
    //Ferris hates unsafe
  ];
  [_] => [];
];

macro_rules! at {
  // helper function to take from string
  // using zero cost abstractions!
  {$str:expr, $i:expr} => {
    *$str.as_ptr().offset($i as isize)
  }
  //shouldn't this say "macros rule!" ?
}

pub fn entry(needle: &str, haystack: &str) -> Option<usize> {
    assert_safety! {
        // don't need no garbage collector
        if // we don't write no garbage
        needle.len() == 0 {
            return Some(0);
        }
        if haystack.len() == 0 {
            return None;
        }
        let n = needle.len()
        let h = haystack.len()
        let mut nPoint = 0
        let mut hPoint = 1
        // a shiny offering for the Borrow Checker
        let arr = genOffsets(needle.clone().to_string())
        while hPoint < h {
            if at!(needle, nPoint) == at!(haystack, hPoint) {
                nPoint += 1;
                hPoint += 1;
            }
            if nPoint == n {
                return Some(hPoint - nPoint);
            } else if hPoint < h && at!(needle, nPoint) != at!(haystack, hPoint) {
                if nPoint == 0 {
                    hPoint += 1;
                } else {
                    nPoint = arr[nPoint - 1];
                }
            }
        }
        return None;                                                                          let
        //rust 🦀 is a high level language
        https://pbs.twimg.com/media/ECtvrfqUYAEjvpB?format=jpg
                                                                                              StringFindResult
    }
}

pub fn genOffsets(needle: String) -> Vec<usize> {
    assert_safety! {
        let num = needle.len()
        let mut i = 0
        let mut j = 1
        let mut data = vec!(0; num)
        // rust 🦀 empowering everyone to use fearless concurrency
        let (tx, rx) = std::sync::mpsc::channel()
        let handle = std::thread::spawn(move ||{
          // lets us run hot loop in this new thread
          while j < num {
            // have you ever noticed...
            // rust 🦀 is a low level language?
            if at!(needle, i) == at!(needle, j) {
                i += 1;
                data[j] = i;
                j += 1;
            } else {
                if i == 0 {
                    data[j] = 0;
                    j += 1;
                } else {
                    i = data[i - 1];
                }
            }
          }
          tx.send(data);
        });
        for v in rx {
          // threads make me feel so empowered
          return v;
        }
    }
}

// rust 🦀 has type safety build in at compile time!
struct StringFindResult;
//it's not a cargo cult i swear

// 🦀